//****************************************************************************
//	aisa54w.pas
//
//	aISA-P54W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit aisa54w;

interface

uses
	Windows;

{ Errors }

const
	AISA54_SUCCESS							= 0;	 { Successfully proccessed }
	AISA54_ERR_SYSTEM						= 1;	 { Call GetLastError() }
	AISA54_ERR_NO_DEVICE				= 2;	 { No card }
	AISA54_ERR_IN_USE						= 3;	 { Device is in use }
	AISA54_ERR_INVALID_SLOT			= 4;	 { Invalid logical slot }
	AISA54_ERR_RESOURCE					= 5;	 { Resource exhaustion }
	AISA54_ERR_INVALID_PORT			= 6;	 { Invalid port }
	AISA54_ERR_INVALID_ARGUMENT = 7;	 { Invalid argument }

{ Direction }

const
	AISA54_DIR_A_OUTPUT	= 0 shl 0;
	AISA54_DIR_A_INPUT	= 1 shl 0;
	AISA54_DIR_B_OUTPUT	= 0 shl 1;
	AISA54_DIR_B_INPUT	= 1 shl 1;
	AISA54_DIR_C_OUTPUT	= 0 shl 2;
	AISA54_DIR_C_INPUT	= 1 shl 2;
	AISA54_DIR_D_OUTPUT	= 0 shl 3;
	AISA54_DIR_D_INPUT	= 1 shl 3;
	AISA54_DIR_E_OUTPUT	= 0 shl 4;
	AISA54_DIR_E_INPUT	= 1 shl 4;
	AISA54_DIR_F_OUTPUT	= 0 shl 5;
	AISA54_DIR_F_INPUT	= 1 shl 5;

{ Port numbers }

const
	AISA54_PORT_A	= 0;
	AISA54_PORT_B	= 1;
	AISA54_PORT_C	= 2;
	AISA54_PORT_D	= 3;
	AISA54_PORT_E	= 4;
	AISA54_PORT_F	= 5;


{ Miscellaneous }

const
	AISA54_MAX_SLOTS	= 16;	{ Maximum number of slots }


{ Device ID }

const
	AISA54_DEVICE_ID	= $00005054;


const
	AISA54_MAX_PORT_W = 6;	{ aISA-P54W̃|[g }
	AISA54_MAX_PORT_H = 3;	{ aISA-P54H̃|[g }

const
	AISA54_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA54_DLL_NAME = 'aisa54.dll';		{ DLL }

function Aisa54wDllOpen: Boolean;		{ DLL [h }
function Aisa54wDllClose: Boolean;	{ DLL A[h }


const
	AISA54_SLOT_AUTO = $ffff;

{ aISA-P54W/H DLL,Driver̃o[Wԍ擾 }
function Aisa54wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P54W/H̎gp錾 }
function Aisa54wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P54W/H̎gpJ }
function Aisa54wClose(wLogSlot: Word): Boolean;


{ |[g擾 }
function Aisa54wGetNumPorts(wLogSlot: Word; var pdwNumPorts: DWord): Boolean;

{ Resource infomation structure }

const
		AISA54_MAX_MEM	=	 9;
		AISA54_MAX_IO		= 20;
		AISA54_MAX_IRQ	=	 7;
		AISA54_MAX_DMA	=	 7;

type
		TAISA54RESOURCE = record
				dwNumMemWindows:DWord;																	{ Not used }
				dwMemBase:			array [1 .. AISA54_MAX_MEM] of DWord;		{ Not used }
				dwMemLength:		array [1 .. AISA54_MAX_MEM] of DWord;		{ Not used }
				dwMemAttrib:		array [1 .. AISA54_MAX_MEM] of DWord;		{ Not used }
				dwNumIOPorts:		DWord;																	{ Num IO ports }
				dwIOPortBase:		array [1 .. AISA54_MAX_IO] of DWord;		{ I/O port base }
				dwIOPortLength: array [1 .. AISA54_MAX_IO] of DWord;		{ I/O port length }
				dwNumIRQs:			DWord;																	{ Num IRQ info }
				dwIRQRegisters: array [1 .. AISA54_MAX_IRQ] of DWord;		{ IRQ list }
				dwIRQAttrib:		array [1 .. AISA54_MAX_IRQ] of DWord;		{ IRQ Attrib list }
				dwNumDMAs:			DWord;																	{ Not used }
				dwDMALst:				array [1 .. AISA54_MAX_DMA] of DWord;		{ Not used }
				dwDMAAttrib:		array [1 .. AISA54_MAX_DMA] of DWord;		{ Not used }
				dwReserved1:		array [1 .. 3] of DWord;								{ Not used }
		end;

PAISA54RESOURCE = ^TAISA54RESOURCE;

{ \[X擾 }
function Aisa54wGetResource(wLogSlot: Word; pResInfo: PAISA54RESOURCE): Boolean;


{ fBNV̏Ԃ擾 }
function Aisa54wGetDirections(wLogSlot: Word; var pdwDirections: DWord): Boolean;
{ fBNVZbg }
function Aisa54wSetDirections(wLogSlot: Word; dwDirections: DWord): Boolean;


{ Cӂ̃|[gf[^ }
function Aisa54wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa54wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-P54W/H̃G[R[h }
function Aisa54wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa54GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa54Create = function(var pwLogSlot: Word): Bool; stdcall;
	TAisa54Close = function(wLogSlot:	Word): Bool; stdcall;
	TAisa54GetNumPorts = function(wLogSlot: Word; var pwNumPorts: DWord): Bool; stdcall;
	TAisa54GetResource = function(wLogSlot: Word; pres: PAISA54RESOURCE):	Bool; stdcall;
	TAisa54GetDirections = function(wLogSlot: Word; var	pbmDirections: DWord): Bool; stdcall;
	TAisa54SetDirections = function(wLogSlot: Word; dwDirections:	DWord):	Bool; stdcall;
	TAisa54InPort = function(wLogSlot: Word; dwLogPort: DWord; var pbInValue: Byte): Bool; stdcall;
	TAisa54OutPort = function(wLogSlot: Word; dwLogPort: DWord; bOutValue: Byte): Bool; stdcall;
	TAisa54GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa54wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa54GetVersion: TAisa54GetVersion;
	pAisa54Create: TAisa54Create;
	pAisa54Close: TAisa54Close;
	pAisa54GetNumPorts: TAisa54GetNumPorts;
	pAisa54GetResource: TAisa54GetResource;
	pAisa54GetDirections: TAisa54GetDirections;
	pAisa54SetDirections: TAisa54SetDirections;
	pAisa54InPort: TAisa54InPort;
	pAisa54OutPort: TAisa54OutPort;
	pAisa54GetLastError: TAisa54GetLastError;


//****************************************************************************
// 		aisa54.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA54_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa54wGetDllExportFunc = False then
  begin
		Aisa54wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa54.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-P54W/H DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-P54W/H̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54Create(pwLogSlot);
end;

//****************************************************************************
// 		aISA-P54W/H̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54Close(wLogSlot);
end;

//****************************************************************************
// 		aISA-P54W/H̃|[g擾
// 		wLogSlot		ׂfoCX
//				pdwNumPorts |[gi[AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wGetNumPorts(wLogSlot: Word; var pdwNumPorts: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54GetNumPorts(wLogSlot, pdwNumPorts);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pResInfo \[Xi[\̂̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wGetResource(wLogSlot: Word; pResInfo: PAISA54RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// 		fBNV̏Ԃ擾
// 		wLogSlot			ׂfoCX
//				pdwDirections Ԃi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wGetDirections(wLogSlot: Word; var pdwDirections: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54GetDirections(wLogSlot, pdwDirections);
end;

//****************************************************************************
// 		fBNVZbg
// 		wLogSlot		 ZbgfoCX
//				dwDirections Zbge
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wSetDirections(wLogSlot: Word; dwDirections: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54SetDirections(wLogSlot, dwDirections);
end;

//****************************************************************************
// 		Cӂ̃|[gf[^
// 		wLogSlot	͂foCX
//				dwPort		͂|[g
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// 		Cӂ̃|[gփf[^o
// 		wLogSlot	o͂foCX
//				dwPort		o͂|[g
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa54wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa54OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// 		aISA-P54W/H̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa54wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA54_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa54GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 	  DLLGNX|[g֐AhX̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Aisa54wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa54GetVersion ̃AhX擾
	pAisa54GetVersion := GetProcAddress(hDLL, 'Aisa54GetVersion');
	if @pAisa54GetVersion = nil then Exit;

	// Aisa54Create ̃AhX擾
	pAisa54Create := GetProcAddress(hDLL, 'Aisa54Create');
	if @pAisa54Create = nil then Exit;

	// Aisa54Close ̃AhX擾
	pAisa54Close := GetProcAddress(hDLL, 'Aisa54Close');
	if @pAisa54Close = nil then Exit;

	// Aisa54GetNumPorts ̃AhX擾
	pAisa54GetNumPorts := GetProcAddress(hDLL, 'Aisa54GetNumPorts');
	if @pAisa54GetNumPorts = nil then Exit;

	// Aisa54GetResource ̃AhX擾
	pAisa54GetResource := GetProcAddress(hDLL, 'Aisa54GetResource');
	if @pAisa54GetResource = nil then Exit;

	// Aisa54GetDirections ̃AhX擾
	pAisa54GetDirections := GetProcAddress(hDLL, 'Aisa54GetDirections');
	if @pAisa54GetDirections = nil then Exit;

	// Aisa54SetDirections ̃AhX擾
	pAisa54SetDirections := GetProcAddress(hDLL, 'Aisa54SetDirections');
	if @pAisa54SetDirections = nil then Exit;

	// Aisa54InPort ̃AhX擾
	pAisa54InPort := GetProcAddress(hDLL, 'Aisa54InPort');
	if @pAisa54InPort = nil then Exit;

	// Aisa54OutPort ̃AhX擾
	pAisa54OutPort := GetProcAddress(hDLL, 'Aisa54OutPort');
	if @pAisa54OutPort = nil then Exit;

	// Aisa54GetLastError ̃AhX擾
	pAisa54GetLastError := GetProcAddress(hDLL, 'Aisa54GetLastError');
	if @pAisa54GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

