Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa54.bas
'
'       AISA-P54W/H Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Errors

Global Const AISA54_SUCCESS = 0                ' Successfully proccessed
Global Const AISA54_ERR_SYSTEM = 1             ' Call GetLastError()
Global Const AISA54_ERR_NO_DEVICE = 2          ' No card
Global Const AISA54_ERR_IN_USE = 3             ' Device is in use
Global Const AISA54_ERR_INVALID_SLOT = 4       ' Invalid logical slot
Global Const AISA54_ERR_RESOURCE = 5           ' Resource exhaustion
Global Const AISA54_ERR_INVALID_PORT = 6       ' Invalid port
Global Const AISA54_ERR_INVALID_ARGUMENT = 7   ' Invalid port

' Direction

Global Const AISA54_DIR_A_OUTPUT = &H0
Global Const AISA54_DIR_A_INPUT = &H1
Global Const AISA54_DIR_B_OUTPUT = &H0
Global Const AISA54_DIR_B_INPUT = &H2
Global Const AISA54_DIR_C_OUTPUT = &H0
Global Const AISA54_DIR_C_INPUT = &H4
Global Const AISA54_DIR_D_OUTPUT = &H0
Global Const AISA54_DIR_D_INPUT = &H8
Global Const AISA54_DIR_E_OUTPUT = &H0
Global Const AISA54_DIR_E_INPUT = &H10
Global Const AISA54_DIR_F_OUTPUT = &H0
Global Const AISA54_DIR_F_INPUT = &H20

' Port numbers

Global Const AISA54_PORT_A = 0
Global Const AISA54_PORT_B = 1
Global Const AISA54_PORT_C = 2
Global Const AISA54_PORT_D = 3
Global Const AISA54_PORT_E = 4
Global Const AISA54_PORT_F = 5

' Miscellaneous

Global Const AISA54_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA54_SLOT_AUTO = &HFFFF

' Device ID

Global Const AISA54_DEVICE_ID = &H5054

' Resource infomation structure

Global Const AISA54_MAX_MEM = 9
Global Const AISA54_MAX_IO = 20
Global Const AISA54_MAX_IRQ = 7
Global Const AISA54_MAX_DMA = 7

Type AISA54RESOURCE
    dwNumMemWindows As Long                         ' Not used
    dwMemBase(1 To AISA54_MAX_MEM) As Long          ' Not used
    dwMemLength(1 To AISA54_MAX_MEM) As Long        ' Not used
    dwMemAttrib(1 To AISA54_MAX_MEM) As Long        ' Not used
    dwNumIOPorts As Long                            ' Num IO ports
    dwIOPortBase(1 To AISA54_MAX_IO) As Long        ' I/O port base
    dwIOPortLength(1 To AISA54_MAX_IO) As Long      ' I/O port length
    dwNumIRQs As Long                               ' Num IRQ info
    dwIRQRegisters(1 To AISA54_MAX_IRQ) As Long     ' IRQ list
    dwIRQAttrib(1 To AISA54_MAX_IRQ) As Long        ' IRQ Attrib list
    dwNumDMAs As Long                               ' Not used
    dwDMALst(1 To AISA54_MAX_DMA) As Long           ' Not used
    dwDMAAttrib(1 To AISA54_MAX_DMA) As Long        ' Not used
    dwReserved1(1 To 3) As Long                     ' Not used
End Type

Declare Function Aisa54GetVersion Lib "aisa54" (lpdwDllVer As Long, lpdwDrvVer As Long) As Long
Declare Function Aisa54Create Lib "aisa54" (lpwLogSlot As Integer) As Long
Declare Function Aisa54Close Lib "aisa54" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa54GetNumPorts Lib "aisa54" (ByVal wLogSlot As Integer, lpdwNumPorts As Long) As Long
Declare Function Aisa54GetResource Lib "aisa54" (ByVal wLogSlot As Integer, lpres As AISA54RESOURCE) As Long
Declare Function Aisa54GetDirections Lib "aisa54" (ByVal wLogSlot As Integer, lpbmDirections As Long) As Long
Declare Function Aisa54SetDirections Lib "aisa54" (ByVal wLogSlot As Integer, ByVal dwDirections As Long) As Long
Declare Function Aisa54InPort Lib "aisa54" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, lpbInValue As Byte) As Long
Declare Function Aisa54OutPort Lib "aisa54" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Declare Function Aisa54GetLastError Lib "aisa54" (ByVal wLogSlot As Integer) As Long
