Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa54w.bas                                                               *
'*                                                                           *
'* aISA-P54W/H                                                           *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA54_DLL_NAME = "aisa54.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA54_MAX_PORT_W = 6    ' aISA-P54W̃|[g
Global Const AISA54_MAX_PORT_H = 3    ' aISA-P54H̃|[g

Global Const AISA54_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa54.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wDllOpen() As Boolean
    
    Aisa54wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA54_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Aisa54wGetDllExportFunc() = False Then
        Aisa54wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa54wDllOpen = True

End Function

'*****************************************************************************
'*    aisa54.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wDllClose() As Boolean

    Aisa54wDllClose = True
    
    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa54wDllClose = False

End Function

'*****************************************************************************
'*    aISA-P54W/H DLL,Driver̃o[Wԍ擾                         *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    Aisa54wGetVersion = False
    
    If hDLL = 0 Then Exit Function
    
    If Aisa54GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
        
    Aisa54wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-P54W/H̔Cӂ̃foCX̎gp錾                            *
'*    pwLogSlot  gpfoCXi[AhX                      *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wCreate(pwLogSlot As Integer) As Boolean

    Aisa54wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa54Create(pwLogSlot) = 0 Then Exit Function
    
    Aisa54wCreate = True

End Function

'*****************************************************************************
'*    aISA-P54W/H̔Cӂ̃foCX̎gpJ                            *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wClose(wLogSlot As Integer) As Boolean

    Aisa54wClose = False
    
    If hDLL = 0 Then Exit Function

    If Aisa54Close(wLogSlot) = 0 Then Exit Function
    
    Aisa54wClose = True

End Function

'*****************************************************************************
'*    aISA-P54W/H̃|[g擾                                        *
'*    wLogSlot    ׂfoCX                                         *
'*        pdwNumPorts |[gi[                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wGetNumPorts(wLogSlot As Integer, pdwNumPorts As Long) As Boolean

    Aisa54wGetNumPorts = False

    If hDLL = 0 Then Exit Function

    If Aisa54GetNumPorts(wLogSlot, pdwNumPorts) = 0 Then Exit Function
    
    Aisa54wGetNumPorts = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pResInfo \[Xi[\̂̃AhX                    *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wGetResource(wLogSlot As Integer, pResInfo As AISA54RESOURCE) As Boolean
    
    Aisa54wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Aisa54GetResource(wLogSlot, pResInfo) = 0 Then Exit Function
    
    Aisa54wGetResource = True

End Function

'*****************************************************************************
'*    fBNV̏Ԃ擾                                         *
'*    wLogSlot      ׂfoCX                                       *
'*        pdwDirections Ԃi[                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wGetDirections(wLogSlot As Integer, pdwDirections As Long) As Boolean

    Aisa54wGetDirections = False

    If hDLL = 0 Then Exit Function

    If Aisa54GetDirections(wLogSlot, pdwDirections) = 0 Then Exit Function
    
    Aisa54wGetDirections = True

End Function

'*****************************************************************************
'*    fBNVZbg                                             *
'*    wLogSlot     ZbgfoCX                                    *
'*        dwDirections Zbge                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wSetDirections(wLogSlot As Integer, dwDirections As Long) As Boolean
    
    Aisa54wSetDirections = False
    
    If hDLL = 0 Then Exit Function

    If Aisa54SetDirections(wLogSlot, dwDirections) = 0 Then Exit Function
    
    Aisa54wSetDirections = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        dwPort    ͂|[g                                           *
'*        pbInValue ̓f[^i[                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    Aisa54wInPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa54InPort(wLogSlot, dwPort, pbInValue) = 0 Then Exit Function
    
    Aisa54wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        dwPort    o͂|[g                                           *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa54wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    Aisa54wOutPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa54OutPort(wLogSlot, dwPort, bOutValue) = 0 Then Exit Function
    
    Aisa54wOutPort = True

End Function

'*****************************************************************************
'*    aISA-P54W/H̃G[R[h                                          *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa54wGetLastError(wLogSlot As Integer) As Long
    
    Aisa54wGetLastError = AISA54_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function

    Aisa54wGetLastError = Aisa54GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa54wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Aisa54wGetDllExportFunc = False
    
    ' Aisa54GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa54Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54Create")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54Close")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54GetNumPorts ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54GetNumPorts")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54GetResource")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54GetDirections ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54GetDirections")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54SetDirections ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54SetDirections")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54InPort")
    If pFunc = 0 Then Exit Function
    
    ' Aisa54OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa54GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa54GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa54wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function

